--fun.lua
--
--@Autor: Alex2009(www.Alex2009.de)
--
--Modifizierung erst nach rcksprache mit mir(Alex2009) erlaubt.
--Modification allowed back only after consultation with me(Alex2009).

fun = {};
fun_mt = Class(fun, Placeable);
InitObjectClass(fun, "fun");

function fun:new(isServer, isClient, customMt)
    local self = Placeable:new(isServer, isClient, fun_mt);
    registerObjectClassName(self, "fun");
    return self;
end;

function fun:delete()
    if self.FunScriptSound ~= nil then
        delete(self.FunScriptSound);
    end;
    removeTrigger(self.FunScriptTrigger);
    unregisterObjectClassName(self);
    fun:superClass().delete(self);
end;

function fun:deleteFinal()
    fun:superClass().deleteFinal(self);
end;

function fun:load(xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom)
    if not fun:superClass().load(self, xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom) then
        return false;
    end;
    local xmlFile = loadXMLFile("TempXML", xmlFilename);

    --Variabeln setzen...
    self.FunScriptActive = false;
    self.FunScriptCount = 50;

    --Baum Object suchen...
    self.FunScriptObject = getChildAt(self.nodeId, 1);
    
    --Lichter laden...
    self.FunScriptLightTab = {};
    local count = 0;
    local maxcount = getNumOfChildren(getChildAt(getChildAt(self.FunScriptObject,0),2)) - 1;
    while true do
        if count <= maxcount then
            local LightIndex = getChildAt(getChildAt(getChildAt(self.FunScriptObject,0),2),count);
            if LightIndex == 0 or LightIndex == nil then
                print("(Weihnachtsbaum v2.0) Loaded " .. count-1 .. " lights.");
                break;
            end;
            self.FunScriptLightTab[count] = {index=LightIndex}
            count = count + 1;
        else
            print("(Weihnachtsbaum v2.0) Loaded " .. count .. " lights.");
            break;
        end;
        count = count + 1;
    end;
    self.FunScriptLoaded = true;
    for k,v in pairs(self.FunScriptLightTab) do
        local r=math.random(0.01,10);
        local g=math.random(0.01,10);
        local b=math.random(0.01,10);
        setShaderParameter(v.index, "partScale", r, g, b, 0, false)  
    end;   
    delete(xmlFile);
    self.FunScriptActive = true;
    return true;
end;

function fun:update(dt)
    if self.FunScriptActive then
        self.FunScriptCount=(self.FunScriptCount-1);
        rotate(self.FunScriptObject, 0, -0.0006*dt, 0);
        if(self.FunScriptCount <= 0) then
            for k,v in pairs(self.FunScriptLightTab) do
                local r=math.random(0.01,10);
                local g=math.random(0.01,10);
                local b=math.random(0.01,10);
                setShaderParameter(v.index, "partScale", r, g, b, 0, false)  
            end;
            self.FunScriptCount = 60;
        end;
    end;
end;
registerPlaceableType("fun", fun);